<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="`gimli` is a library for reading and writing the DWARF debugging format."><meta name="keywords" content="rust, rustlang, rust-lang, gimli"><title>gimli - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../normalize.css"><link rel="stylesheet" type="text/css" href="../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../dark.css" disabled><link rel="stylesheet" type="text/css" href="../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../storage.js"></script><script defer src="../crates.js"></script><script defer src="../main.js"></script><noscript><link rel="stylesheet" href="../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../favicon.svg"></head><body class="rustdoc mod crate"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../gimli/index.html"><div class="logo-container"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../gimli/index.html"><div class="logo-container"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"><a href="#">Crate gimli</a></h2><div class="sidebar-elems"><div class="block"><ul><li class="version">Version 0.26.2</li><li><a id="all-types" href="all.html">All Items</a></li></ul></div><section><div class="block"><ul><li><a href="#modules">Modules</a></li><li><a href="#structs">Structs</a></li><li><a href="#enums">Enums</a></li><li><a href="#traits">Traits</a></li><li><a href="#types">Type Definitions</a></li></ul></div></section></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../gimli/index.html"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Crate <a class="mod" href="#">gimli</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../src/gimli/lib.rs.html#1-76">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><p><code>gimli</code> is a library for reading and writing the
<a href="https://dwarfstd.org/">DWARF debugging format</a>.</p>
<p>See the <a href="./read/index.html">read</a> and <a href="./write/index.html">write</a> modules
for examples and API documentation.</p>
<h3 id="cargo-features"><a href="#cargo-features">Cargo Features</a></h3>
<p>Cargo features that can be enabled with <code>gimli</code>:</p>
<ul>
<li>
<p><code>std</code>: Enabled by default. Use the <code>std</code> library. Disabling this feature
allows using <code>gimli</code> in embedded environments that do not have access to
<code>std</code>. Note that even when <code>std</code> is disabled, <code>gimli</code> still requires an
implementation of the <code>alloc</code> crate.</p>
</li>
<li>
<p><code>read</code>: Enabled by default. Enables the <code>read</code> module. Use of <code>std</code> is
optional.</p>
</li>
<li>
<p><code>write</code>: Enabled by default. Enables the <code>write</code> module. Always uses
the <code>std</code> library.</p>
</li>
</ul>
</div></details><h2 id="reexports" class="small-section-header"><a href="#reexports">Re-exports</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left import-item"><code>pub use crate::<a class="mod" href="constants/index.html" title="mod gimli::constants">constants</a>::*;</code></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left import-item"><code>pub use crate::<a class="mod" href="read/index.html" title="mod gimli::read">read</a>::*;</code></div><div class="item-right docblock-short"></div></div></div><h2 id="modules" class="small-section-header"><a href="#modules">Modules</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="mod" href="constants/index.html" title="gimli::constants mod">constants</a></div><div class="item-right docblock-short"><p>Constant definitions.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="mod" href="leb128/index.html" title="gimli::leb128 mod">leb128</a></div><div class="item-right docblock-short"><p>Read and write DWARF’s “Little Endian Base 128” (LEB128) variable length
integer encoding.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="mod" href="read/index.html" title="gimli::read mod">read</a></div><div class="item-right docblock-short"><p>Read DWARF debugging information.</p>
</div></div></div><h2 id="structs" class="small-section-header"><a href="#structs">Structs</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.AArch64.html" title="gimli::AArch64 struct">AArch64</a></div><div class="item-right docblock-short"><p>ARM 64-bit (AArch64) architecture specific definitions.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Arm.html" title="gimli::Arm struct">Arm</a></div><div class="item-right docblock-short"><p>ARM architecture specific definitions.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.BigEndian.html" title="gimli::BigEndian struct">BigEndian</a></div><div class="item-right docblock-short"><p>Big endian byte order.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.DebugAbbrevOffset.html" title="gimli::DebugAbbrevOffset struct">DebugAbbrevOffset</a></div><div class="item-right docblock-short"><p>An offset into the <code>.debug_abbrev</code> section.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.DebugAddrBase.html" title="gimli::DebugAddrBase struct">DebugAddrBase</a></div><div class="item-right docblock-short"><p>An offset to a set of entries in the <code>.debug_addr</code> section.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.DebugAddrIndex.html" title="gimli::DebugAddrIndex struct">DebugAddrIndex</a></div><div class="item-right docblock-short"><p>An index into a set of addresses in the <code>.debug_addr</code> section.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.DebugArangesOffset.html" title="gimli::DebugArangesOffset struct">DebugArangesOffset</a></div><div class="item-right docblock-short"><p>An offset into the <code>.debug_aranges</code> section.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.DebugFrameOffset.html" title="gimli::DebugFrameOffset struct">DebugFrameOffset</a></div><div class="item-right docblock-short"><p>An offset into the <code>.debug_frame</code> section.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.DebugInfoOffset.html" title="gimli::DebugInfoOffset struct">DebugInfoOffset</a></div><div class="item-right docblock-short"><p>An offset into the <code>.debug_info</code> section.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.DebugLineOffset.html" title="gimli::DebugLineOffset struct">DebugLineOffset</a></div><div class="item-right docblock-short"><p>An offset into the <code>.debug_line</code> section.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.DebugLineStrOffset.html" title="gimli::DebugLineStrOffset struct">DebugLineStrOffset</a></div><div class="item-right docblock-short"><p>An offset into the <code>.debug_line_str</code> section.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.DebugLocListsBase.html" title="gimli::DebugLocListsBase struct">DebugLocListsBase</a></div><div class="item-right docblock-short"><p>An offset to a set of location list offsets in the <code>.debug_loclists</code> section.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.DebugLocListsIndex.html" title="gimli::DebugLocListsIndex struct">DebugLocListsIndex</a></div><div class="item-right docblock-short"><p>An index into a set of location list offsets in the <code>.debug_loclists</code> section.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.DebugMacinfoOffset.html" title="gimli::DebugMacinfoOffset struct">DebugMacinfoOffset</a></div><div class="item-right docblock-short"><p>An offset into the <code>.debug_macinfo</code> section.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.DebugMacroOffset.html" title="gimli::DebugMacroOffset struct">DebugMacroOffset</a></div><div class="item-right docblock-short"><p>An offset into the <code>.debug_macro</code> section.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.DebugRngListsBase.html" title="gimli::DebugRngListsBase struct">DebugRngListsBase</a></div><div class="item-right docblock-short"><p>An offset to a set of range list offsets in the <code>.debug_rnglists</code> section.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.DebugRngListsIndex.html" title="gimli::DebugRngListsIndex struct">DebugRngListsIndex</a></div><div class="item-right docblock-short"><p>An index into a set of range list offsets in the <code>.debug_rnglists</code> section.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.DebugStrOffset.html" title="gimli::DebugStrOffset struct">DebugStrOffset</a></div><div class="item-right docblock-short"><p>An offset into the <code>.debug_str</code> section.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.DebugStrOffsetsBase.html" title="gimli::DebugStrOffsetsBase struct">DebugStrOffsetsBase</a></div><div class="item-right docblock-short"><p>An offset to a set of entries in the <code>.debug_str_offsets</code> section.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.DebugStrOffsetsIndex.html" title="gimli::DebugStrOffsetsIndex struct">DebugStrOffsetsIndex</a></div><div class="item-right docblock-short"><p>An index into a set of entries in the <code>.debug_str_offsets</code> section.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.DebugTypeSignature.html" title="gimli::DebugTypeSignature struct">DebugTypeSignature</a></div><div class="item-right docblock-short"><p>A type signature as used in the <code>.debug_types</code> section.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.DebugTypesOffset.html" title="gimli::DebugTypesOffset struct">DebugTypesOffset</a></div><div class="item-right docblock-short"><p>An offset into the <code>.debug_types</code> section.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.DwoId.html" title="gimli::DwoId struct">DwoId</a></div><div class="item-right docblock-short"><p>An optionally-provided implementation-defined compilation unit ID to enable
split DWARF and linking a split compilation unit back together.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.EhFrameOffset.html" title="gimli::EhFrameOffset struct">EhFrameOffset</a></div><div class="item-right docblock-short"><p>An offset into the <code>.eh_frame</code> section.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Encoding.html" title="gimli::Encoding struct">Encoding</a></div><div class="item-right docblock-short"><p>Encoding parameters that are commonly used for multiple DWARF sections.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.LineEncoding.html" title="gimli::LineEncoding struct">LineEncoding</a></div><div class="item-right docblock-short"><p>Encoding parameters for a line number program.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.LittleEndian.html" title="gimli::LittleEndian struct">LittleEndian</a></div><div class="item-right docblock-short"><p>Little endian byte order.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.LocationListsOffset.html" title="gimli::LocationListsOffset struct">LocationListsOffset</a></div><div class="item-right docblock-short"><p>An offset into either the <code>.debug_loc</code> section or the <code>.debug_loclists</code> section,
depending on the version of the unit the offset was contained in.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.RangeListsOffset.html" title="gimli::RangeListsOffset struct">RangeListsOffset</a></div><div class="item-right docblock-short"><p>An offset into either the <code>.debug_ranges</code> section or the <code>.debug_rnglists</code> section,
depending on the version of the unit the offset was contained in.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.RawRangeListsOffset.html" title="gimli::RawRangeListsOffset struct">RawRangeListsOffset</a></div><div class="item-right docblock-short"><p>An offset into either the <code>.debug_ranges</code> section or the <code>.debug_rnglists</code> section,
depending on the version of the unit the offset was contained in.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Register.html" title="gimli::Register struct">Register</a></div><div class="item-right docblock-short"><p>A DWARF register number.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.RiscV.html" title="gimli::RiscV struct">RiscV</a></div><div class="item-right docblock-short"><p>RISC-V architecture specific definitions.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.X86.html" title="gimli::X86 struct">X86</a></div><div class="item-right docblock-short"><p>Intel i386 architecture specific definitions.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.X86_64.html" title="gimli::X86_64 struct">X86_64</a></div><div class="item-right docblock-short"><p>AMD64 architecture specific definitions.</p>
</div></div></div><h2 id="enums" class="small-section-header"><a href="#enums">Enums</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.DwarfFileType.html" title="gimli::DwarfFileType enum">DwarfFileType</a></div><div class="item-right docblock-short"><p>The “type” of file with DWARF debugging information. This determines, among other things,
which files DWARF sections should be loaded from.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.Format.html" title="gimli::Format enum">Format</a></div><div class="item-right docblock-short"><p>Whether the format of a compilation unit is 32- or 64-bit.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.RunTimeEndian.html" title="gimli::RunTimeEndian enum">RunTimeEndian</a></div><div class="item-right docblock-short"><p>Byte order that is selectable at runtime.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.SectionId.html" title="gimli::SectionId enum">SectionId</a></div><div class="item-right docblock-short"><p>An identifier for a DWARF section.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.UnitSectionOffset.html" title="gimli::UnitSectionOffset enum">UnitSectionOffset</a></div><div class="item-right docblock-short"><p>An offset into the <code>.debug_info</code> or <code>.debug_types</code> sections.</p>
</div></div></div><h2 id="traits" class="small-section-header"><a href="#traits">Traits</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.Endianity.html" title="gimli::Endianity trait">Endianity</a></div><div class="item-right docblock-short"><p>A trait describing the endianity of some buffer.</p>
</div></div></div><h2 id="types" class="small-section-header"><a href="#types">Type Definitions</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="type" href="type.NativeEndian.html" title="gimli::NativeEndian type">NativeEndian</a></div><div class="item-right docblock-short"><p>The native endianity for the target platform.</p>
</div></div></div></section></div></main><div id="rustdoc-vars" data-root-path="../" data-current-crate="gimli" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>